package com.npenkov.mobile;

import java.util.HashMap;
import java.util.Map;

import com.google.gson.Gson;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.TextView;

public class TestmobileActivity extends Activity 
		implements OnClickListener, ICallbackHandler {
	private Button btnRunWebService;
	private TextView txtField;
	private TextView txtServerIP;
	private AlertDialog.Builder builder;
	
    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
        
        builder = new AlertDialog.Builder(this);

		btnRunWebService = (Button) findViewById(R.id.btnCallService);
		txtField = (TextView) findViewById(R.id.textView);
		txtServerIP = (TextView) findViewById(R.id.editIPAddress);

		btnRunWebService.setOnClickListener(this);
    }
    
    public void onClick(View v) {
		builder.setMessage("Run REST request?").setCancelable(false)
				.setNegativeButton("OK", new DialogInterface.OnClickListener() {
					public void onClick(DialogInterface dialog, int id) {
						dialog.cancel();
						callWebService();
					}
				});
		AlertDialog alert = builder.create();
		alert.show();
	}

	private void callWebService() {
		Map<String, String> params = new HashMap<String, String>();
		String serverIP = txtServerIP.getText().toString();
		WebService webService = new WebService(
				"http://"+ serverIP+":8080/testweb/re/first/", 
				"tellMe", params, this, WebService.GET_METHOD);
		webService.execute();
	}

	@Override
	public void response(String response) {
		Log.i("callMethod", "response");
		try {
			MsgObj msg = new Gson().fromJson(response, MsgObj.class);
			txtField.setText(msg.getMsgText());
		} catch (Exception e) {
			Log.d("Error: ", "Processing of " + response );
			if (e != null && e.getMessage() != null) Log.d("Error: ", e.getMessage() );
			else if (e != null) Log.d("Error: ", e.toString());
			else Log.d("Error: ", "Null Exception");
		}
	}
}